/*
 *	Atari Ghostscript 3.01 Beta release 1
 */

GHOSTSCRIPT OVERVIEW:	9/94

Aladdin Ghostscript 3.01 is a PostScript language interpreter which is
free to non-comercial users (the kernal is written and maintained by
Peter Deutsch -- ghost@aladdin.com).  It can be used to convert
PostScript files into formats suitable for non-PostScript printers, or
to display PostScript files on the screen.  It is also quite nice for
PostScript code development.

Once again, the Atari-specific code has been restructured, since it
had grown beyond what its simple structure could support.  This has
created new possibilities, and probably lots of new bugs.

The binary distribution of the beta release contains an executable
which is more self-sufficent than previous versions of Ghostscript.
All of the PS start-up files are now compiled into the executable, as
are three fonts (Courier, Times-Roman, and Charter-Italic -- Courier
has replaced ugly as the default font).  Unfortunately, this
contributes to the already bloated size of the executable and reduces
the flexibility of GS, since the start-up files can no longer be
customized.  For the general distribution, I plan to have a version of
GS without everything compiled in.

Aside from additional fonts, the only external files needed to use
Atari GS are the ASCII and PostScript help files.  Placing these files
in a directory included in the GS_LIB environment variable will make
them available to the program.  The default location is f:\gs\help.
Of course, you can delete them if you like.

The standard source and fonts for 3.01 (you can use the old fonts if
you want) are available from ftp.cs.wisc.edu.  This site can be
accessed from the Atari Ghostscript WWW page at
http://godel.ph.utexas.edu/Members/timg/gs.html.

Further on in this file is a brief description of some features which
are specific to the Atari platform.  You may want to review it after
getting GS installed.


SYSTEM REQUIREMENTS:

To run GS 3.01, you probably need a minimum of 4M ram and 1M of free
disk space (as long as you write no files to disk).  How much you can
get by with really depends on the PostScript files you want to
process, since ALOT of memory is allocated dynamically.  If you get
all of the GS fonts, you will need another 3M of disk space.  I run GS
on a 4M 520ST with an 85M hard drive and a monochrome monitor, so it
is hard for me to estimate a minimum hardware configuration.  You can
always try with less.

Keep in mind that a 300dpi image requires a little over 1M of memory,
so high resolution printing requires either lots of memory or band
printing (see use.doc).  Color is a real memory hog, so you may have
to decrease the resolution for color images (screen images cannot be
printed in bands).  Documents which load lots of fonts can also hog
lots of ram. (Try using the -dNOCACHE option if you think fonts are
using too much memory.)

You can probably get by without a hard drive if you are willing to use
only the ghostscript default font.  The font files take up about 3 Meg
of disk space.  For graphics, the default font is fine, but text output
won't be great.


INSTALLATION:

If the PostScript support files are not compiled into the executable,
will need a set of PostScript support files (in the ps directory),
some fonts (at least the default font -- in the fonts directory), and a
file called fontmap.  On-line help files (in the help directory) are
optional.  When GS is executed, it reads a number of the PostScript
files to initialize itself.  If it cannot find these initialization
files, Ghostscript will ABORT!  The fontmap file contains a list of
which fonts reside in which disk files.  Ghostscript must be able to
locate all of these files in order to execute successfully.

>>>>>>>>>> This will almost always require the user to set an
>>>>>>>>>> environment variable called GS_LIB. If you don't set this
>>>>>>>>>> variable, GS will most likely abort on start-up.

When Ghostscript needs a file, it searchs a list of directories
until it finds what it needs. Which directories it searches is
determined as follows:

1.) The current directory is searched first.

2.) Directories to be searched can be specified from the GS command
line with the -I option.

3.) Directories specified by the GS_LIB environment variable are
checked next.  Gem users may be unfamiliar with environment variables.
Basically, this is just a global variable stored by the computer in a
location which is accessible by all programs running on the machine.
Most shells have commands that allow you to set environment variables.
If you are running from the desktop, you may need an auto-folder
program (I believe GEMENV is the name of one such program) which will
set environment variables for you.

Ghostscript will look for a global environment variable named GS_LIB.
If the environment variable GS_LIB is set to "c:\gs,d:\gs,e:\gs" GS will
search the directories c:\gs, d:\gs, and e:\gs in sequence for the files
that it needs.  This comma-separated list of directories is called a
"path".

4.) If the GS_LIB variable is not set, GS searches a default path of
".,f:\gs\help,f:\gs\ps,f:\gs,f:\gs\fonts" This corresponds to my setup.
When GS needs a file, it first looks in the current directory (.), then
in f:\gs\help, then in f:\gs\ps, f:\gs\fonts, and finally in f:\gs.

I have Ghostscript installed as follows:

f:\gs		GS source and executable,
f:\gs\ps	GS PostScript support files and
		other PostScript source (pictures),
f:\gs\fonts	GS fonts and the fontmap file,
f:\gs\help	GS ASCII and PostScript help files.

If your installation corresponds to the default path, you need not
worry about any environment variables.  If the directories used in
your installation do not correspond to the default path, you will want
to set up your computer to automatically define GS_LIB to be a COMMA
separated path (corresponding to your setup) for Ghostscript to
search.  If you specify file paths on the command line, you may use
either '/' or '\' as a path separator.

To install:

1) Copy gs301b.zoo to the desired directory (f:\gs to use the default
	search path).

2) Unpack the archive with 'zoo e// gs301b.zoo'
	This will produce a directory structure as follows:
	. (current directory)	GS executable,
	.\ps			GS PostScript support files and examples,
	.\fonts			Default font and fontmap,
	.\help			PostScript and ASCII help files.

	If you want the root gs directory to be somewhere besides
	f:\gs, define the environment variable GS_LIB to be a comma
	separated search path which contains the files in the
	'ps', help, and 'fonts' directories. You will probably want to
	set up your system so that this environment variable is
	defined	automatically at boot time (or you can use gemGS
	to define it whenever GS is run).

USAGE:

To use ghostscript:

1) To display a file on the screen:
	Type 'gs file1.ps file2.ps ...' on the command line. The default
	device is the screen at 80 dpi. You can specify (with the -r
	option) as much resolution as you have memory for, but it may
	take forever to construct your image.

	GS will open a console window, and will write some initialization
	messages to it. The mouse will turn to a busy bee while GS is
	creating a bitmap of the image. If you are using the screen
	(stvdi) device, an image window will eventually open and the
	image will be displayed (this can take a long while for complicated
	files or high resolutions). You can then scroll around the image
	using the scroll bars or the cursor keys.

	Usually the last postscript command on a PS page will be
	"showpage". The showpage command causes the page to be displayed
	and then waits for the user to enter a <return> before proceeding
	to the next page. When all pages have been displayed, GS displays
	a GS> prompt in the console window. Postscript commands typed in
	the console window will then be executed by the PS interpreter. For
	example, typing "(file.ps) run" after the prompt will cause
	file.ps to be displayed. This is a useful thing to know, since
	it allows you to display more images without having to wait
	through another long GS initialization.

	Alternatively, you can just type "gs" on the command line,
	double-click on gs.gtp, or install gs to be automatically
	executed by double-clicking on PostScript files. Once
	inside GS, you can use the menu items to perform operations
	like selecting the page size, the output device, and the
	image resolution.

	On-line help about any menu item can be invoked by holding
	down any meta key (control, alt, or shift) while selecting
	the menu item.

	The use of windows may be disabled by setting the environment
	variable GS_WIN "off". In this case, you can move around the
	image with the cursor keys, and type "q" when you have finished
	viewing the image. Press the help key for further information.

2) To use a printer device:

	A printing device can be selected from the "Options" menu,
	or can be specified from the command line.  Type "gs
	-sDEVICE=djet500 file.ps" on the command line for a deskjet
	500, "gs -sDEVICE=epson file.ps", etc.  Type "gs -h" for a
	list of available printer devices.  If you like, you can
	define a shell alias for "gs -sDEVICE=djet500".  The printer
	output will be written by default in a file called
	"gs_pr.XXX", where XXX is a unique number.  Selecting the
	"Print ..." menu item will allow output to be sent to a named
	file or directly to the printer.

	From the command line, output can be redirected to a file of
	your choosing, or to the printer with the
	"-sOutputFile=filename" option.  OutputFile=PRN: or CEN:
	will send output to the printer port (CEN: prints faster,
	but is less compatible). If the CEN: output file has not
	worked for you in the past, please try it again. I think
	this bug may now be fixed.

ATARI FEATURES:

Most of the Atari-specific features are documented in the on-line
help, so I won't go into much detail here.  Here is a brief overview
of the Atari-specific features:

1.) When GS is started, a console window is opened and stdin, stdout,
and stderr are directed to it.  Use of windows may be disabled by
setting the GS_WIN environment variable to "off".  Menus are provided to
change things like resolution, output device, and page size without
exiting and restarting GS.  This can save a good deal of time, since GS
takes a good deal of time to initialize.

All of the windows are standard, with all of the standard gadgets.
Everything operates in the normal fashion, except for the arrow buttons
in the scroll bars of the image window. In addition to their normal
function, these can be used to move to the top, bottom, left edge, or
right edge of the window. This is accomplished by holding down a meta
key (cntl, alt, or shift) while clicking on the arrow.

The x coordinate of text windows will always snap to the nearest word,
so it may not end up exactly where you put it when you move the
window.  This is an attempt to keep the text word aligned, which is
supposed to improve text output speed.  Text output speed is improved
if the console window is topped.  In this case, text output is
accelerated by not clipping or walking the usual rectangle list.

2.) The stvdi screen device supports 1-, 2-, 4-, 8-, 16- and hopefully
24-bit color.  The 24-bit color has not been thoroughly tested, so it
may not work properly, if at all.  Please note that only so much that
can be done with 2-bit color. I am considering changing the 2-bit mode
to a greyscale device.

Vdi routines are used to determine the screen parameters and to copy to
the screen, so graphics should work with lots of different screen
devices.  The price of compatibility, however, is alot of image
transformation.  Some transformations are written in assembler in an
attempt to speed things up a bit.

The screen driver allocates colors dynamically as the GS kernal requests
them.  For 2 and 4 bit color, GS spaces colors equally throughout the
color cube, and then approximates the needed colors by dithering the two
closest colors in the palette.  Because of the dynamic color allocation,
you may see colors changing on your screen while GS is running.  GS
attempts to avoid changing the color of the desktop and of window
gadgets, but if your image needs lots of colors, this may not be
possible.  Of course, the original palette is restored when GS exits.
Thanks to Markus Wenzel for the routines to set and save the color
palette.

3.) There are two ways to send output directly to the printer.
Including '-sOUTPUTFILE=PRN:' on the command line will send output to
the centronics port via Gemdos.  The name 'OutputFile' can be used
instead of 'OUTPUTFILE' if desired.  The option '-sOUTPUTFILE=CEN:' will
write output directly to the centronics port.  These options can also be
selected from menus after GS is running.

The routines for direct centronics output were contributed by Chris
Strunk (CS-TeX)--THANKS!  Direct centronics output is generally much
faster (about a factor of 4 for heavy graphics).  A subtle bug that
caused centronics printing not to work on some machines may now be
fixed (thanks to Andrew Paterson), so give it a try if it failed to
work in the past.

For those with an Atari SLM printer, this driver sends output directly
to the printer (running the Diablo emulator), so there is no need to
specify the OUTPUTFILE.  Some problems have been reported with using the
old Diablo emulator, so the newest one is recommended.  Also, the SLM
driver is a major memory hog, and users may encounter memory problems
when printing certain documents (like those with lots of fonts).

4.) The number of available drivers has increased to the point that it
is not feasible to include all that an ST owner might reasonably use.
The current choice of 21 drivers was decided mostly by a vote of GS
users on the internet (a couple were included at my whim).  Type 'gs
-h' for a list of the available drivers.

stvdi    - The screen device. Supports 1, 2, 4, 8, 16, and 24 bit color,
slm      - Atari SLM laser printer (thanks to Robert Stabl),
gemimg   - GEM bitmap format (thanks to Marcus Haebler),
djet500  - HP DeskJet 500,
djet500c - Color HP DeskJet 500,
cjd500   - Another DeskJet 500c driver -- higher quality output -- slower,
cjd550   - DeskJet 550c driver,
laserjet - HP LaserJet (and old deskjets),
bj10e    - Cannon BubbleJet,
ap3250   - Epson ESC/P 2,
st800    - Epson Stylus 800,
epson    - Epson 9 and 24 pin printers (limited resolutions),
eps9high - High resolution Epson 9-pin device (makes multiple passes),
epsonc   - Color epson printers,
necp6	 - NEC 360 dpi printer,
gifmono  - GIF monochrome bitmap format,
gif8     - GIF 8-bit color format,
pbmraw   - Mono portable bitmap format,
ppmraw   - Color portable bitmap format,

5.) The following environment variables are specific to the Atari port
of GS. See use.doc for standard environment variables (like GS_LIB).

GS_WIN:	Set this to "off" to disable windows. Otherwise the value of
	this variable is ignored.

GS_DISPLAY: Set this to "chunky8" to tell GS that your screen hardware
	uses chunky pixel format. I don't think any graphics boards
	actually use this format, but if they do, this will allow GS
	to skip two image format transformations and save some time.
	Otherwise GS will transform GS's native chunky format to standard
	GEM color planes, and then transform back to chunky format for
	display.

GS_DEBUG: This is used by me during debugging. I doubt it is of interest
	to anyone else.


KNOWN BUGS, LIMITATIONS and POSSIBLE PROBLEMS:

See the doc files for some known bugs and problems.

1.) 24-bit color has not been tested; it may not work properly.

2.) Control-C to abort printing is not handled very gracefully.

3.) Fatal errors are still not handled gracefully.  An alert is used to
keep the console window from closing before the error message can be
read, but the alert itself may cover some of the error message.

4.) Some PageStream output tickles a bug in the GS kernal, causing a
crash.

5.) The CEN: output option may not work properly on some STEs and TTs.

6.) Programs which take control of the printer port can interfere with
Ghostscript's Atari SLM laser printer device.  Also, you should have the
latest Diablo emulator to avoid output problems under MultiTOS.


TIPS:

Here are a few miscellaneous tips.

1) Read the supplied documentation!  It is a bit sparse for beginners,
but it is helpful and is quicker than sending me questions.  Use.doc is
the most important file for casual users.  GS is an excellent tool for
learning PostScript programming, but it is not the intention of the docs
to teach PS to you.  If you want to learn PostScript programming, you
will probably need to buy a PS programming book.

2) Try to arrange things so that you don't have to restart GS very
often.  This startup takes a good deal of time.  I have tried to make
this easier by providing menus to perform some common operations.  If
you MUST restart GS often, putting the initialization files in a ram
disk significantly decreases initialization time (at least on my
system).

3) An archive named ps_picts.zoo contains some files on which to test
ghostscript.  These are some of the files that where used to test the
port.

4) GS can be used to view or print the output of dvips (TeX dvi to PS
translator).  The combination of TeX (a typesetting program), dvips,
and GS can be used to preview TeX documents which contain graphics at
high resolution (if you need this sort of thing and have the memory).
I have gone up to 300dpi and it seems to work OK.  Dvips allows PS
graphics to be easily included in TeX documents.  Note that 300dpi TeX
documents will not look very good when viewed on the screen at 80dpi.

5) You can change the ghostscript prompt by editing the gs_init.ps
file.  Search the file for GS or >, and then change this to whatever
you want the prompt to be.  Many other changes can be made in this
file to alter the behavior of GS.  For example, you can redefine the
'showpage' command so that it doesn't wait around for a CR to be typed
after every page (this can also be done from the command line or a
menu).  European users can also set the default page size to A4 in
this file.

6) You may find interesting things in the following Usenet newsgroups:
	gnu.ghostscript.bug
	comp.lang.postscript
	comp.sources.postscript


ACKNOWLEDGMENTS:

Many kind people have contributed to the Atari version of Ghostscript.
Some of the more direct contributions are:

Hauke Hess:	Original screen driver upon which stvdi was based,
Robert Stabl:	The Atari SLM laser printer driver,
Marcus Haebler:	360 dpi NEC P6 and GEM image drivers,
Chris Strunk:	Contributed code for direct centronics printing,
Steve Eker:	Contributed assembly image transformation algorithms,
Steven Ourada:	Contributed assembly image transformation algorithms,
Markus Wenzel:	Color palette save and restore routines,
J. Bammi:	For gcc and numerous library bug fixes.
Andrew Paterson: Possible fix to the centronics bug.

Please forgive me if I forgot to mention an important contribution,
and gently remind me of my omission.

FOR MORE INFO:

The original source files, docs, and fonts can be obtained from
ftp.cs.wisc.edu.

There is an Atari Ghostscript WWW page at
http://godel.ph.utexas.edu/Members/timg/gs.html, which contains a
Ghostscript Frequently Asked Questions list, in addition to some screen
shots and other information. This WWW page and the email address
have an uncertain future. They will, however, most likely be valid
through December 1994.

Send bug reports to:

Tim Gallivan
Department of Physics
University of Texas
Austin, TX
timg@landau.ph.utexas.edu
