/* Copyright (C) 1989, 1992, 1993 Aladdin Enterprises.  All rights reserved.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.  */

/* gp_atar2.h */

/* Ghostscript header file for gp_atar2.c */

#include <stdarg.h>
#include <gemdefs.h>
#include <aesbind.h>
#include <vdibind.h>

#include "memory_.h"
#include "string_.h"
#include "gx.h"
#include "gp.h"
#include "stream.h"
#include "gxiodev.h"			/* must come after stream.h */
#include "st_defs.h"

/* Real versions of the following functions are needed in gp_atar2. */

#undef fputc
#undef fputs
#undef fwrite

/* Use a pseudo file device to get win_stdio_init called
 * at the right time.
 */

private iodev_proc_init(win_stdio_init);
private stream_proc_process(win_std_read_process);
private stream_proc_process(win_std_write_process);

/* end gp_atar2.h */
